module REGISTER #(
  parameter BITS = 8
)(
  input                 i_clk,
  input                 i_rst,
  input                 i_in,
  input                 i_out,
  inout      [BITS-1:0] io_bus,
  input                 i_bus_active,
  output reg [BITS-1:0] o_reg
);

always @(posedge i_clk || i_rst) begin
  if (i_rst)
    o_reg <= (BITS)'d0;
  else if (i_in)
    o_reg <= (i_bus_active) ? io_bus : (BITS)'d0;
end

assign io_bus = i_out ? o_reg : {BITS{1'bz}};

endmodule
